	include "include\doorsos.h"	;les librairies utilises par le programme
	include "include\util89.h"

	xdef _ti89			;le programme est un programme TI89
	xdef _main			;il commence  l'adresse main
	xdef _comment			;il possde un espace commentaire

up	equ	KEY_UP			;liste des "variables", en fait les constantes du programme.
down	equ	KEY_DOWN
left	equ	KEY_LEFT
right	equ	KEY_RIGHT
KF5	equ	272
ESC	equ	264

masque	equ	%01111100

SetFont MACRO				;Macro choisissant la police  utiliser
        move.w \1,-(a7)			;place le premier argument sur la pile. L'argument a la longueur d'un mot
        jsr tios::FontSetSys
        addq.l #2,a7			;dplace l'adresse du pointeur de pile de deux. L'adresse du pointeur de pile est cod sur un mot double.
        ENDM

WriteStr	MACRO			;Macro crivant un texte  un endroit prcis,
        move.w \1,-(a7)			;dans une couleur dtermin, un texte point par une adresse
        pea \2(pc)
        move.w \3,-(a7)
        move.w \4,-(a7)
        jsr tios::DrawStrXY
        lea 10(a7),a7
        ENDM

_main					;dpart du programme
	move.l #1,d7			;d7 = emplacement vertical de la croix
	move.l #1,d6			;d6 = emplacement horizontal de la croix
	move.l #1,d5			;d5 = numro de l'lment
	movea.l #$4C1D,a2		;a2 = adresse du dbut de l'cran + 1D, pour le centrage de l'image

Ecran1	jsr util::zap_screen		;efface l'cran
	include "ecran.asm"		;affiche l'cran
	SetFont #1			;choisit la police 1 comme police d'affichage
        move.w #4,-(a7)
        pea masse(pc)
        move.w #92,-(a7)
        move.w #2,-(a7)			;placement des infos sur la pile
        jsr tios::DrawStrXY		;affiche la phrase point par le label masse  l'emplacement (2;92) en couleur normale
        lea 10(a7),a7			;enlve les infos de la pile
	bra Affich1			;va afficher les infos de l'lment en cours

KEY	jsr util::idle_loop		;attente de l'appui sur une touche
	cmp.w #KEY_RIGHT,d0		;compare la valeur retourne par la sous-routine et la valeur de la touche DROITE
	beq Droit			;si la valeur est la mme, alors aller au label droit
	cmp.w #KEY_LEFT,d0
	beq Gauche
	cmp.w #KEY_DOWN,d0
	beq Bas
	cmp.w #KEY_UP,d0
	beq Haut

	cmp.w #ESC,d0			;si la touche appuye est ESC, alors aller  exit
	beq exit
	cmp.w #KF5,d0
	bne.s KEY

F5	jsr util::zap_screen		;Caractristiques du programme affichs lors de l'appui sur F5
	SetFont #2
	WriteStr #4,nom,#5,#7
	SetFont #1
	WriteStr #4,version,#20,#40
	SetFont #0
	WriteStr #4,auteur,#35,#28
	WriteStr #4,Site,#50,#22
	SetFont #1
	jsr util::idle_loop
	bra Ecran1

Droit	cmp.w #112,d5			;Dispatching des diffrents cas  observer si la touche appuye est la touche DROITE
	beq KEY
	addq.w #1,d5
	addq.w #1,d6
	cmp.w #19,d6
	bne.s SD1
	moveq.w #1,d6
	addq.w #1,d7
SD1	cmp.w #2,d6
	bne.s SD2
	cmp.w #1,d7
	bne.s SD2
	moveq.w #18,d6
SD2	cmp.w #3,d6
	bne.s SD4
	cmp.w #3,d7
	bgt.s SD3
	moveq.w #13,d6
	bra.s SD4
SD3	cmp.w #6,d7
	blt.s SD4
	cmp.w #7,d7
	bgt.s SD4
	addq.w #2,d7
SD4	cmp.w #18,d6
	bne.s SD5
	cmp.w #8,d7
	blt.s SD5
	moveq.w #4,d6
	subq.w #2,d7
SD5	bsr Efface
	bra Affich1

Gauche	cmp.w #1,d5			;Dispatching des diffrents cas  observer si la touche appuye est la touche GAUCHE
	beq KEY
	subq.w #1,d5
	subq.w #1,d6
	cmp.w #0,d6
	bne.s SG1
	moveq.w #18,d6
	subq.w #1,d7
SG1	cmp.w #17,d6
	bne.s SG2
	cmp.w #1,d7
	bne.s SG2
	moveq.w #1,d6
SG2	cmp.w #12,d6
	bne.s SG3
	cmp.w #3,d7
	bgt.s SG3
	move.w #2,d6
SG3	cmp.w #3,d6
	bne.s SG4
	cmp.w #6,d7
	blt.s SG4
	cmp.w #7,d7
	bgt.s SG4
	addq.w #2,d7
	moveq.w #17,d6
SG4	cmp.w #2,d6
	bne.s SG5
	cmp.w #8,d7
	blt.s SG5
	moveq.w #2,d6
	subq.w #2,d7
SG5	bsr Efface
	bra Affich1

Bas	cmp.w #1,d5			;Dispatching des diffrents cas  observer si la touche appuye est la touche BAS
	beq SB1
	cmp.w #13,d5
	blt SB2
	cmp.w #39,d5
	blt SB3
	beq KEY
	cmp.w #72,d5
	blt.s SB5
	cmp.w #81,d5
	blt.s SB5
	cmp.w #86,d5
	blt.s SB6
	cmp.w #104,d5
	blt KEY
SB7	sub.w #46,d5
	bra.s SBF
SB6	addq.w #1,d7
	sub.w #14,d5
	bra.s SBF
SB5	add.w #32,d5
	bra.s SBF
SB3	add.w #18,d5
	bra.s SBF
SB2	addq.w #8,d5
	bra.s SBF
SB1	addq.w #2,d5
SBF	addq.w #1,d7
	bsr Efface
	bra Affich1

Haut	cmp.w #3,d5			;Dispatching des diffrents cas  observer si la touche appuye est la touche HAUT
	blt KEY
	beq SH5
	cmp.w #10,d5
	blt KEY
	cmp.w #21,d5
	blt SH1
	cmp.w #31,d5
	blt KEY
	cmp.w #57,d5
	blt SH2
	beq KEY
	cmp.w #67,d5
	blt SH3
	cmp.w #72,d5
	blt.s SH4
SH7	sub.w #32,d5
	bra.s SHF
SH5	subq.w #2,d5
	bra.s SHF
SH4	subq.w #1,d7
	add.w #14,d5
	bra.s SHF
SH3	add.w #46,d5
	bra.s SHF
SH2	sub.w #18,d5
	bra.s SHF
SH1	subq.w #8,d5
SHF	subq.w #1,d7
	bsr Efface

Affich1					;Affiche la croix ainsi que le nom et la masse molaire de l'lment
	move.l d5,d2			;place le contenu de d5 dans d2 (numro de l'lment)
	mulu.w #30,d2			;comme chaque lment prend #30 octet de place, multiplier #30 par le numro de l'lment
	sub.w #30,d2			;soustraire #31  d2, car le premier lment n'est pas  compter
	lea Table(PC),a6		;mettre l'adresse effective de la base de donnes dans a6
	adda.l d2,a6			;ajouter  l'adresse de la base de donnes le dplacement pour trouver l'lment
	movea.l a6,a3			;mettre le contenu de a5 dans a3

	move.w #4,-(a7)			;choisir la couleur normale
	pea (a3)			;mettre le contenu de a3 sur la pile
	move.w #82,-(a7)		;coordonnes
	move.w #2,-(a7)
        jsr tios::DrawStrXY		;crire le nom de l'lment sur l'cran
	lea 8(a7),a7			;retirer les infos sauf celles de la couleur
	lea 21(a3),a3			;ajouter 21 au contenu de a3
	pea (a3)			;ritrer l'opration d'criture  l'cran
	move.w #92,-(a7)
	move.w #50,-(a7)
        jsr tios::DrawStrXY
	lea 10(a7),a7
					;dessin de la croix
	move.l d7,d4			;mettre d7 dans d4 (placement vertical de l'lment)
	mulu #240,d4			;multiplier cet emplacement par 240 (chaque ligne du tableau correspond  8 lignes de l'acran, soit 8 * 30 octets
	add.l d6,d4			;ajouter au contenu de d7, celui de d4 (placement horizontal de l'lment)
	sub.l #240,d4			;soustraire au contenu de d7 une ligne de l'cran (pour l'alignement)
	movea.l d4,a2			;mettre dans a2 le contenu de d4

	cmp.w #8,d7			; quelle ligne est-on ?
	bge.s SA1			;si on est  la ligne 8 ou 9, aller  SA1
	lea $4C96(a2),a2		;ajouter  a2 l'adresse par dfaut du tableau
	bra.s SA2			;aller  SA2
SA1	lea $4CF0(a2),a2		;ajouter  a2 l'adresse par dfaut du tableau, plus le dcalage de la srie des lanthanides et des actinides
SA2	eor.b #masque,(a2)		;placer la croix (ou exclusif)
	eor.b #masque,30(a2)
	eor.b #masque,60(a2)
	eor.b #masque,90(a2)
	eor.b #masque,120(a2)

	bra KEY

exit	rts				;fin du programme TI

;***Sous-routine***
Efface	eor.b #masque,(a2)		;Efface la croix  l'emplacement mmoire indiqu par le contenu de a2
	eor.b #masque,30(a2)
	eor.b #masque,60(a2)
	eor.b #masque,90(a2)
	eor.b #masque,120(a2)
	rts

;***Donnes***
	include "Databasl.asm"

masse	dc.b "masse :          g/mol",0

nom	dc.b "Tableau priodique",0
auteur	dc.b "Matthieu Brucher a.k.a. Miles",0
version	dc.b "version light",0
Site	dc.b "http://www.citeweb.net/MMiles",0

_comment				;commentaire affich  l'extrieur du programme
	dc.b "Tableau priodique light 3.10",0

	end				;fin du programme asm
